Stable
------
Version 0.9.0-1						2025/4
 * Implemented CQT spectrum and CQT spectrogram (beta version).
 * Implemented piano-key display for spectrum/spectrogram view.
 * Implemented indication of musical note name in cursor information
   for spectrum/spectrogram view.
 * Fixed a bug that spectrogram view after zoom-in with large factor
   sometimes freezes.
 * Fixed a bug that scroll and zoom-out in spectrogram view after zoom-in
   with large factor do not work correctly.
 * Fixed a bug that spectrogram view provides sometimes wrong time information.
 * Fixed a bug that plugin errors sometimes cause a crash.
 * Fixed a bug that the color of grid lines is wrong in printing.
 * Optimized layout of spectrogram view for printing.
 * Enhanced the function of waveform cropping from label information.
 * Fixed a bug that some items in the preference dialog related to labels
   do not work.
 * Added some items related to the region label in the preference dialog.
 * Fixed a bug that drawing selected region in the log-frequency axis
   does not work correctly.
 * Added partial support for the dark mode of Windows (the menu bar and the menus).
 * Fixed a bug that the cursor to indicate current calculation position
   of spectrogram is sometimes not shown.
 * Changed drawing of cursor information into that with white background
   so as to make the information legible.
 * Fixed a bug that moving to the head by scrolling the overview display
   sometimes fails.
 * Added feature of alignment of the view region between spectrum view
   and spectrogram view.

Version 0.8.6-2						2024/5
 * Implemented the text field that specifies the file name of generated signal
   in the waveform generate dialog.
 * Fixed a bug on Mac that sometimes causes a crash when there is no device to record.
 * Fixed a bug on Mac that drag & drop files to the application icon will
   cause a freeze when a modal dialog is displayed.
 
Version 0.8.6						2023/4
 * Implemented the property dialog.
 * Reworded the word "File information" before into "File metadata".
 * Fixed a bug that some of the metadata contents are not updated after saving the file.
 * Fixed a bug that saving a file sometimes causes a crash.
 * Changed ID3 tag related behavior of MP3 file.
 * Fixed bugs of input_caf and output_caf plugins that CAF file I/O works
   only for files of 16 bits/sample.

Version 0.8.5-1						2023/3
 * Added native support for M1/M2 chip of Mac.
 * Added functions of spectrum plot and spectrogram view using logarithmic
   frequency axis.
 * Fixed a bug that the region in the overview is sometimes slightly shifted.
 * Fixed a bug that the numbers of frequency axis cannot be updated in zooming
   spectrogram view.
 * Fixed a bug that low and high frequency edges of the spectrogram view aren't
   drawn correctly.
 * Added native support for float-format WAV file by input_wav and output_wav plugins
   (formerly support through libsndfile).

Version 0.8.4-10					2021/8
 * Fixed a bug of ALAC plugin that sometimes freezes since it wrongly tries
   to read WAV file.

Version 0.8.4-9						2020/11/11
 * Fixed a bug (spComponent's bug) that gtk3 version always crashes
   in the case where Wayland backend is used.
   
Version 0.8.4-8						2019/12/24
 * Fixed a bug that opening label sometimes causes a crash.
 * Fixed a bug that a whitespace is sometimes wrongly added to label's data
   after the label file have been overwritten.

Version 0.8.4-7						2019/4/14
 * Added support for I/O of Monkey's Audio files on macOS and Linux.
 * Fixed a bug that opening a Monkey's Audio files causes crashes on Windows 64bit.

Version 0.8.4-6						2018/11/22
 * Rebuilt the Windows executable by using Visual Studio 2017.
 * Fixed a bug of input_caf, input_alac, and so on that the opened file is
   not properly closed.

Version 0.8.4-5						2016/6/4
 * Updated some documents.
 * Rebuilt the Windows executable by using Visual Studio 2015.
 * Fixed a bug that the cursor line of the overview canvas doesn't move in
   playing sound introduced from version 0.8.4.
 
Version 0.8.4-4						2016/4/30
 * Fixed a bug that the file format information is sometimes strange.
 * Fixed a bug of printing function for PS files.

Version 0.8.4-3						2014/8/29
 * Added support for I/O of FLAC/CAF/ALAC files.
 * Fixed a bug that some fields in the file information dialog sometimes 
   are destroyed for some file formats.
 * Fixed a bug that the zoom factor in landscape printing is invalid.
 * Implemented printing feature in Cocoa version.
 * Fixed a bug that playback of a non-16bit format file totally generates noise 
   in Cocoa version.
 * Fixed a bug that drawing area of the filtering dialog of Cocoa version
   sometimes cannot be drawn.

Version 0.8.4-2						2014/3/31
 * Fixed a bug that causes a crash when an unsupported file is opened.

Version 0.8.4-1						2012/3/29
 * Fixed a bug that the font dialog sometimes crashes in Cocoa version.

Version 0.8.3-1						2012/9/3
 * Implemented Mac OS X Cocoa version (alpha version).
 * Added official support for 64bit OS.
 * Implemented operation by mouse wheel officially.
 * Changed implementation of structure of waveform data.
 * Enhanced drag & drop behavior of gtk version.

Version 0.8.2-2b					2009/9/9
 * Updated `save by label' function.

Version 0.8.2-1b					2009/9/7
 * Implemented `save by label' function.

Version 0.8.1-6b					2009/1/5
 * Implemented gain setting in percentage in the waveform generation dialog.

Version 0.8.1-5b					2008/5/26
 * Added support for playing back float-format files.
 * Fixed a bug that a shortcut file will be opened as a sound file on Windows.

Version 0.8.1-3b					2007/11/11
 * Added a button to turn on synchronous play to the tool bar.
 * Implemented playing position moving by scrolling window in synchronous
   play mode.

Version 0.8.1-2b					2007/10/31
 * Implemented playing position moving by rewind and forward buttons 
   in the cursor pause mode.

Version 0.8.1-1b					2007/10/29
 * Fixed a bug essencially that causes a crash by multi-thread related problems.
 * Implemented cursor pause function.
 * Added a button to turn on loop play to the tool bar.

Version 0.8.0-4b					2007/10/21
 * Fixed a bug quickly that causes a crash by multi-thread related problems
   which often happens on multi-core CPU machies.

Version 0.8.0-3b					2007/10/4
 * Implemented size setting of the information area in the preference dialog.
 * Implemented `Selection' tab in the information area which enables
   area selection in point by a keyboard.

Version 0.8.0-2b					2007/10/3
 * Implemented font setting of drawing area in the preference dialog.
 * Enhanced functions in the information area.

Version 0.8.0-1b					2007/10/2
 * Implemented printing function.

Version 0.6.12-5b					2007/8
 * Fixed a bug that a part of `file information' dialog cannot be edited 
   after saving the file.

Version 0.6.12-4b (private release; Mac OS X only)	2006/7/21
 * Enhanced stability on Mac OS X.

Version 0.6.12-3b (private release)			2005/10/24
 * Implemented filtering.

Version 0.6.12-2b (private release)			2005/9/12
 * Fixed a bug that the smoothed spectrum has strange value at a half of
   nyquist frequency.

Version 0.6.12-1b (private release)			2005/8/24
 * Implemented functions of waveform generation and sound recording.
 * Changed implementation of FFT in spectrum and spectrogram into more fast 
   FFT by Intel SPL (Windows) / Altivec (Mac).

Version 0.6.11-4b (informal release; Windows and Mac OS X only)	2005/2/13
 * Fixed a bug that a help menu does not work correctly on Mac OS.
 * Updated spAudio.

Version 0.6.11-3b (informal release; Windows and Mac OS X only)	2004/7/25
 * Added support for an online help.
 * Added support for ASIO drivers (audio driver reading by plugins).
 * Made reading speed fast slightly.
 * Changed behavior of execution so that duplicated execution is not allowed.
   When spwave already exists in execution, input files will be sent to the window.
 * Fixed a bug that the file can be played in the overview of a spectrum window.
 * Fixed a bug that two labels cannot be shifted across in moving it.
 * Changed behavior in editing labels so that the labels are selected.

Version 0.6.11-2b (private release)
Version 0.6.11-1b (informal release; Windows only)	2004/2/10
 * Implemented displaying spectrogram.
 * Fixed a bug that the time position of waveforms is sometimes not exact on zooming in.
 * Fixed a bug that writing labels including only time information fails.
 * Fixed a bug that the quit menu is sometimes disabled.
 * Fixed a bug that noise is sometimes generated when a single channel is selected.
 * Fixed a bug that an active window is sometimes not changed on Mac OS X.
 * Fixed a bug that playing sound by right-click on the overview window sometimes fails 
   in an area near the end of the file.
 * Fixed a bug that reading and writing 32 bit float files by libsndfile doesn't work.
 * Changed behavior of delete key so that a label is removed when a selected label exists.

Version 0.6.10 (private release)

Version 0.6.9-1b (informal release; Windows only)	2003/8/25
 * Implemented zoom in/out of amplitude.
 * Implemented displaying amplitude valie in percentage.
 * Implemented displaying amplitude value in decibels.
 * Implemented analysis functions such as smoothed group group delay.
 * Implemented specifying displayed region on start up.
 * Fixed a bug that some analysis types use only real part spectrum.
 * Fixed a bug that reading/writing region labels sometimes causes a crash.
 * Fixed a bug that labels can be selected when labels are invisible.
 * Fixed a bug that the overview of analysis windows is not updated after setting is changed.
 * Fixed a bug that the overview is not updated after reloading.
 * Fixed a bug that the x axis of spectral windows is strange 
   when the time axis is `separated second'.

Version 0.6.8-3				2002/4/29
 * Fixed a bug that compilation using some versions of gcc fails 
   because of SJIS characters.
 * Fixed a bug that labels including only one column cannot be loaded.

Version 0.6.8-2				2002/4/7
 * Fixed a bug that 8bit files sometimes cannot be saved.
 * Fixed a bug that causes a crash on Mac OS 8.

Version 0.6.8				2002/3/11
 * Implemented displaying overview of waveform.
 * Implemented maximize.
 * Implemented inserting a pause.
 * Added official support for Windows 2000/XP.
 * Fixed a bug that the relation between dB value and rate value is incorrect 
   in the amplify dialog.
 * Fixed a bug that temporary data of a clipboard is not removed after quiting.
 * Implemented enlarging a region by shift + arrow key.
Version 0.6.7-3b (private release)	2002/2/5
Version 0.6.7-2b (private release)	2002/1/18
Version 0.6.7-1b (private release)	2002/1/15
 * Enhanced label handling.
 * Implemented enlarging a region by shift + click.
 * Added support for I/O of Ogg Vorbis file.
 * Implemented the plugin based on libsndfile which adds supports 
   for many file types such as ADPCM WAV and AU.
 * Fixed a bug that information dialog doesn't save a track number.
 * Fixed a bug that labels are sometimes removed by cropping.
 * Fixed a bug that time information is sometimes not updated
   by moving with scroll bar.

Version 0.6.6-1b (beta 1 release for Mac OS X)	2001/10/28
 * Added support for Mac OS X.
 * Implemented preemptive multi-thread edit on Mac OS X based on pthread.
 * Implemented a peak file so as to zoom in/out a big file quickly.
 * Implemented concatenating commands (this is based on a patch provided by 
   Hiroaki GOTO. Thanks.)
 * Fixed a bug that very long files (over 25 minutes approximately 
   in 44.1 kHz sampling, stereo) cannot be loaded correctly.
 * Fixed a bug that the window containing the file that hasn't been saved yet
   will be closed without saving the file on quiting, if just one window exists.
 * Fixed a bug that menu items and tool items intended to be inaccessible 
   sometimes can be clicked on thread editing.
 * Fixed a bug that drawing a waveform is not updated until reading is finished on Mac OS.
 * Reimplemented audio functions on Mac OS so as to decrease audible gaps.
 * Fixed a bug of invalid cursor drawing on Mac OS.
 * Fixed a bug on Mac OS that closing a window on playing sound sometimes causes a crash.

Version 0.6.5				2001/3/12
 * Implemented cut & paste and copy & paste.
 * Implemented multi-thread edit.
 * Implemeted loop play.
 * Implemented region change on playing sound.
 * Implemented changing amplitude value.
 * Implemented displaying progress of reading.
 * Fixed a problem that spwave eats so much CPU time while playing sound on Windows.
 * Fixed a bug of spComponent that causes a crash on Windows 2000.
 * Fixed a bug that resizing a window eats too much resources on Windows.
 * Fixed a bug that a thread sometimes falls into deadlock on stopping processing.
 * Fixed a bug that gtk version falls into deadlock when an edit fails 
  (introduced from version 0.5.2-5).
 * Fixed a bug that some parameters are not updated into files on saving 
   as some formats such as MP3.
 * Fixed a bug of drawing on scrolling by dragging the edge of a region.
 * Fixed a bug that messages for sampling frequency conversion are strange.
 * Fixed a bug that the selected region is not correct on redoing.

Version 0.6.4 (private release)
Version 0.6.3 (private release)
Version 0.6.2 (private release)
Version 0.6.1 (private release)

Version 0.6.0				2001/1/4
 * Implemented selection of each channel of multichannel data.
 * Implemented monauralizing of multichannel data.
 * Fixed a bug that drag & drop is allowed while processing.
 * Fixed a bug that the window displaying spectrum still displays spectrum
   after a file is loaded into the window, when a window associated with the window is analyzed.
 * Fixed a bug that MP3 files that include the ID3 Version 3 tag sometimes
   cannot be loaded (a bug fix of the MPEG input plugin).
 * Fixed a bug that a suitable plugin is not searched correctly.
 * Fixed a bug on Mac OS that causes a crash on closing a dialog by a menu.
 * Fixed a bug that a tab control blinks many times by clicking on Mac OS 9.
 * Added support for smart scrolling on Mac OS 9.


Developmental
-------------
Version 0.5.2-5				2000/11/29
 * Implemented window closing by a default button and an escape key 
   in a dialog on some environments.
 * Implemented focus change by a tab key on Windows.
 * Fixed a bug that drawing of a dialog is strange when the design of Windows is changed.
 * Implemented tool bars and tool tips on Mac OS.
 * Added support for Mac OS 7.5.3 and later.
 * Added support for appearance on Mac OS 8.1 and later.
 * Implemented shortcuts on Mac OS 8.1 and later that use shift and control keys.
 * Fixed a bug that drawing of a dialog of gtk version is strange 
   when the theme is changed.
 * Fixed a bug that some parameters are not initialized when opening a file
   into the spectrum window.
 * Fixed a bug that you can extend a region on the left edge of the window
   even if no region is selected.

Version 0.5.2-4				2000/10/30
 * Fixed a bug that some temporary files cannot be removed on Windows.
 * Changed a default value of sampling frequency conversion.

Version 0.5.2-3				2000/10/26
 * Fixed a bug that spwave cannot exit after saving a file.

Version 0.5.2				2000/10/21
 * Fixed a plugin's critical bug that the saved file with a header changes into
   8000 Hz monaural forcedly. I highly recommend to update spwave and plugins 
   if you use version 0.5.0 or 0.5.1.
 * Added support for opening files by drag & drop (Windows, gtk and Mac OS version).
 * Added support for 24 bit, 32bit, and float 32bit files.
 * Added support for bits/sample conversion.
 * Added support for sampling frequency conversion.
 * Added support for amplitude conversion, fade in, and fade out.
 * Added support for playing sound using thread.
 * Added support for editing using thread (version 0.5.2-2).
 * Fixed a bug of sampling frequency conversion (version 0.5.2-2).
 * Changed undo and redo implementation so as to process fast.
 * Changed the way of getting maximum and minimum value of waveforms.
 * Implemented the preference dialog for plug-ins.
 * Added support for label cropping with waveform cropping.
 * Fixed a bug that the file information cannot be saved 
   without modification of the file.
 * Fixed a bug that temporary files for ulaw change into 8bit linear files.
 * Implemented changing the mouse cursor into the watch cursor on heavy processing.
 * Fixed a bug that the scroll bar is incorrect 
   when the zoom factor is big and the file is very long.
 * Fixed a bug that the zoom factor is wrong after reading a file
   if the window was zoomed in before reading .
 * Fixed a bug that region labels change into normal labels after extraction.
 * Implemented the menu disablement when the region is not set.

Version 0.5.1				2000/8/14
 * Support for waveform extraction by drag & drop.
 * Implemented region labels.
 * Changed some shortcut keys. 
   The shortcut keys of Windows version are worked by Ctrl key mainly.
 * Implemented swapping Alt key and Ctrl key for the shortcuts.
 * Added support for size change of the region by mouse operation.
 * Implemented scrolling on the window edge when selecting a region.
 * Fixed 0.5.0's bug that spwave reads the file header of an autosave file as data. 
 * Changed implementation of the format dialog so as to be shown at startup.

Version 0.5.0				2000/8/7
 * Added support for long files.
 * Added support for a stop function of playing sound.
 * Added support for plug-ins.
 * Added support for undo and redo.
 * Added support for editing file information.
 * Changed implementation of dealing with a label file.
 * Added support for autosaving of an extracted region.
 * Added support for adding a label with a value.

Version 0.3.4-2				1999/6/21
 * Fixed a bug which causes a failure when reading file having 
   Japanese filename on Windows.
 * Fixed version 0.3.3's bug which causes a crash 
   when reading non-existing file.
 * Fixed a bug on Windows that the top and left sides of the canvas are drawed
   with black color when resizing a window.

Version 0.3.4				1999/6/14
 * Added support for displaying scale.
 * Fixed version 0.3.3's bug that the spwave reads wav file header as data. 
 * Fixed a bug on Windows which generates noise when playing sound.

Version 0.3.3-2				1999/6/9
 * Fixed a bug which causes analysis errors for multichannel data.

Version 0.3.3				1999/6/8
 * Added support for analysis.
 * Fixed a bug which causes a crash when reading multichannel raw file.

Version 0.3.2				1999/5/30
 * Added support for labels.
 * Fixed a bug in the preference dialog which causes occasional crash.
 * Fixed a bug when playing file by a shortcut.

Version 0.3.1				1999/5/22
 * Added a tool bar.
 * Fixed a bug in the spComponent.

Version 0.3.0				1999/5/13
 * Improvement of the preference dialog.
 * Added some menu items.


Stable
------
Version 0.4.1				1999/12/17
 * Fixed a bug of Windows version when scrolling.
 * Fixed a bug when reading label.

Version 0.4.0-2				1999/7/21
 * Fixed a drawing bug of GTK version when selecting region.

Version 0.4.0				1999/6/26
 * Almost same as version 0.3.4-2.

Version 0.2.1-3				1999/5/3
 * Fixed a bug on Windows which causes a crash when long file is played
   repeatedly.

Version 0.2.1				1999/4/25
 * Fixed a bug when opening the format selection dialog.
 * Added the simple preference dialog.

Version 0.2.0				1999/4/10
 * First release
